tests/fate.sh
a9dc6111
 #! /bin/sh
 
 config=$1
 
 die(){
     echo "$@"
     exit 1
 }
 
 test -r "$config"  || die "usage: fate.sh <config>"
 
8226e977
 workdir=$(cd $(dirname $config) && pwd)
a9dc6111
 make=make
8b0816cb
 tar='tar c'
a9dc6111
 
 . "$config"
 
 test -n "$slot"    || die "slot not specified"
 test -n "$repo"    || die "repo not specified"
 test -d "$samples" || die "samples location not specified"
 
 lock(){
     lock=$1/fate.lock
     (set -C; exec >$lock) 2>/dev/null || return
     trap 'rm $lock' EXIT
 }
 
 checkout(){
     case "$repo" in
         file:*|/*) src="${repo#file:}"      ;;
         git:*)     git clone "$repo" "$src" ;;
     esac
 }
 
 update()(
     cd ${src} || return
     case "$repo" in
12ad0677
         git:*) git pull --quiet ;;
a9dc6111
     esac
 )
 
 configure()(
     cd ${build} || return
     ${src}/configure                                                    \
         --prefix="${inst}"                                              \
         --samples="${samples}"                                          \
74c847e0
         --enable-gpl                                                    \
a9dc6111
         ${arch:+--arch=$arch}                                           \
         ${cpu:+--cpu="$cpu"}                                            \
         ${cross_prefix:+--cross-prefix="$cross_prefix"}                 \
         ${cc:+--cc="$cc"}                                               \
         ${target_os:+--target-os="$target_os"}                          \
         ${sysroot:+--sysroot="$sysroot"}                                \
         ${target_exec:+--target-exec="$target_exec"}                    \
         ${target_path:+--target-path="$target_path"}                    \
         ${extra_cflags:+--extra-cflags="$extra_cflags"}                 \
         ${extra_ldflags:+--extra-ldflags="$extra_ldflags"}              \
         ${extra_libs:+--extra-libs="$extra_libs"}                       \
         ${extra_conf}
 )
 
 compile()(
     cd ${build} || return
     ${make} ${makeopts} && ${make} install
 )
 
 fate()(
     cd ${build} || return
     ${make} ${makeopts} -k fate
 )
 
673fe599
 clean(){
20e1829d
     rm -rf ${build} ${inst}
673fe599
 }
 
a9dc6111
 report(){
     date=$(date -u +%Y%m%d%H%M%S)
5ffccc00
     echo "fate:0:${date}:${slot}:${version}:$1:$2:${comment}" >report
a9dc6111
     cat ${build}/config.fate ${build}/tests/data/fate/*.rep >>report
8b0816cb
     test -n "$fate_recv" && $tar report *.log | gzip | $fate_recv
a9dc6111
 }
 
 fail(){
     report "$@"
51124db8
     clean
a9dc6111
     exit
 }
 
 mkdir -p ${workdir} || die "Error creating ${workdir}"
 lock ${workdir}     || die "${workdir} locked"
 cd ${workdir}       || die "cd ${workdir} failed"
 
 src=${workdir}/src
eb8da636
 : ${build:=${workdir}/build}
 : ${inst:=${workdir}/install}
a9dc6111
 
 test -d "$src" && update || checkout || die "Error fetching source"
 
 cd ${workdir}
 
 version=$(${src}/version.sh ${src})
32a15a24
 test "$version" = "$(cat version-$slot 2>/dev/null)" && exit 0
 echo ${version} >version-$slot
a9dc6111
 
69a9c80b
 rm -rf "${build}" *.log
a9dc6111
 mkdir -p ${build}
 
 configure >configure.log 2>&1 || fail $? "error configuring"
 compile   >compile.log   2>&1 || fail $? "error compiling"
 fate      >test.log      2>&1 || fail $? "error testing"
 report 0 success
673fe599
 clean